//+------------------------------------------------------------------+
//|                                                    iSpearman.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
#property indicator_minimum -1
#property indicator_maximum  1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Spearman"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

input string SecSymbol="USDCHF";
input ushort iPeriod=15;
ushort period=5;
double buffer[],arr1[][2],arr2[][2],denom,point1,point2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   period=MathMax(period,iPeriod);

   ArrayResize(arr1,period);
   ArrayResize(arr2,period);

   denom=period*(period*period-1);

   point1=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
   point2=SymbolInfoDouble(SecSymbol,SYMBOL_POINT);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   if(rates_total>prev_calculated)
     {
      ArraySetAsSeries(open,true);
      int bars=prev_calculated>0? rates_total-prev_calculated-1:MathMin(rates_total,iBars(SecSymbol,PERIOD_CURRENT))-period-1;

      for(int i=bars; i>=0; i--)
        {
         for(int j=0; j<period; j++)
           {
            int pos=i+j;
            arr1[j][0]=MathRound(open[pos]/point1);
            arr1[j][1]=j;
            arr2[j][0]=MathRound(iOpen(SecSymbol,PERIOD_CURRENT,pos)/point2);
            arr2[j][1]=j;
           }

         ArraySort(arr1);
         ArraySort(arr2);
        
         double sum=0;
         for(int j=0; j<period; j++)
            for(int k=0; k<period; k++)
               if(arr1[j][1]==arr2[k][1])
                 {
                  int d=j-k;
                  sum=sum+d*d;
                  break;
                 }

         buffer[i]=(denom-6*sum)/denom;
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
